{$N+,G+}
{
  祭 ࠤ   ௮樥
}
unit Gradient;
{--------------------}
     interface
{--------------------}
type
  TGradient=record
    Place:byte;
    R:byte;
    G:byte;
    B:byte;
  end;

const
  Grad1:array[0..6] of TGradient=(
  (Place:0;   R:63; G:0;  B:0),
  (Place:43;  R:63; G:0;  B:63),
  (Place:85;  R:0;  G:0;  B:63),
  (Place:127; R:0;  G:63; B:63),
  (Place:170; R:0;  G:63; B:0),
  (Place:213; R:63; G:63; B:0),
  (Place:255; R:63; G:0;  B:0));

  Grad2:array[0..3] of TGradient=(
  (Place:0;   R:62; G:57; B:0),
  (Place:43;  R:27; G:5;  B:26),
  (Place:85;  R:63; G:30; B:0),
  (Place:255; R:0;  G:9;  B:28));

  Grad3:array[0..5] of TGradient=(
  (Place:0;   R:0;  G:0;  B:0),
  (Place:51;  R:63; G:63; B:63),
  (Place:102; R:0;  G:0;  B:0),
  (Place:153; R:63; G:63; B:63),
  (Place:204; R:0;  G:0;  B:0),
  (Place:255; R:63; G:63; B:63));

  Grad4:array[0..6] of TGradient=(
  (Place:0;   R:0;  G:29; B:36),
  (Place:43;  R:7;  G:17; B:26),
  (Place:85;  R:21; G:15; B:26),
  (Place:128; R:0;  G:22; B:0),
  (Place:170; R:17; G:27; B:0),
  (Place:213; R:26; G:26; B:0),
  (Place:255; R:23; G:0;  B:0));

  Grad5:array[0..8] of TGradient=(
  (Place:0;   R:0;  G:45; B:50),
  (Place:31;  R:40; G:0;  B:0),
  (Place:59;  R:0;  G:0;  B:53),
  (Place:82;  R:1;  G:48; B:13),
  (Place:107; R:48; G:46; B:0),
  (Place:135; R:48; G:0;  B:0),
  (Place:168; R:2;  G:23; B:0),
  (Place:214; R:0;  G:0;  B:53),
  (Place:255; R:0;  G:0;  B:25));

procedure GenPalette(Gradient:array of TGradient);

{--------------------}
   implementation
{--------------------}
uses
  Graph;

procedure GenPalette(Gradient:array of TGradient);
var
  i,X1,X2,Y1,Y2,Color:byte;
  R,G,B:byte;

begin
  for Color:=0 to 255 do
  begin
    i:=0;
    while Color>Gradient[i].Place do inc(i);
    X1:=Gradient[i-1].Place;
    X2:=Gradient[i].Place;

    Y1:=Gradient[i-1].R;
    Y2:=Gradient[i].R;
    if Color<>Gradient[i].Place then
      R:=Round( Y1+(Y2-Y1)/(X2-X1)*(Color-X1) )
    else
      R:=Gradient[i].R;

    Y1:=Gradient[i-1].G;
    Y2:=Gradient[i].G;
    if Color<>Gradient[i].Place then
      G:=Round( Y1+(Y2-Y1)/(X2-X1)*(Color-X1) )
    else
      R:=Gradient[i].R;

    Y1:=Gradient[i-1].B;
    Y2:=Gradient[i].B;
    if Color<>Gradient[i].Place then
      B:=Round( Y1+(Y2-Y1)/(X2-X1)*(Color-X1) )
    else
      R:=Gradient[i].R;

    if Color<>0 then
    asm
      mov dx, 03C8h
      mov al, Color
      out dx, al
      inc dx
      mov al, R
      out dx, al
      mov al, G
      out dx, al
      mov al, B
      out dx, al
    end;
  end;
end;

end.